#include "mainwindow.h"
#include "ui_mainwindow.h"
#include <QTime>
#include <QTimer>
#include <QObject>
#include <QFont>
#include <QColor>

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    running = false;
    _timer.setInterval(20);
    connect(&_timer, SIGNAL(timeout()), this, SLOT(onTimer()));
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::on_btnStartStop_clicked()
{
    if (_timer.isActive()){
        _timer.stop();
        _timeLeft = QTime::fromMSecsSinceStartOfDay(_timeLeft.msecsSinceStartOfDay() + QTime::currentTime().msecsSinceStartOfDay() - _lastStart.msecsSinceStartOfDay());
        ui->btnStartStop->setText("Старт");

        ui->label->setStyleSheet("color: black;");
    }
    else {
        _lastStart = QTime::currentTime();
        _timer.start();
        ui->btnStartStop->setText("Стоп");
        ui->label->setStyleSheet("color: red;");
    }
}

void MainWindow::onTimer()
{
    int mseconds = _timeLeft.msecsSinceStartOfDay() + QTime::currentTime().msecsSinceStartOfDay() - _lastStart.msecsSinceStartOfDay();
    ui->label->setText(QTime::fromMSecsSinceStartOfDay(mseconds).toString("mm:ss:zzz"));
}

void MainWindow::on_btnReset_clicked()
{
    _timer.stop();
    ui->btnStartStop->setText("Старт");
    ui->label->setText("00:00:000");
    ui->label->setStyleSheet("color: black;");
    _timeLeft = QTime::fromMSecsSinceStartOfDay(0);
}
